searchNodes=[{"ref":"Mix.Tasks.UaInspector.Download.html","title":"Mix.Tasks.UaInspector.Download","type":"task","doc":"Mix task to download database file(s) from your command line. Arguments When run without arguments the task will display the target directory for the downloaded files and will ask for confirmation before downloading. --force: skip confirmation before downloading --quiet: silences task output (does not imply --force!) Informational README If you are using the default databases from the default remote location an informational README with the filename ua_inspector.readme.md will be placed next to the downloaded file(s). Inside you will find a link to the original database source. The creation of this file can be deactivated by configuration: config :ua_inspector, skip_download_readme: true"},{"ref":"Mix.Tasks.UaInspector.Download.html#run/1","title":"Mix.Tasks.UaInspector.Download.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"UAInspector.html","title":"UAInspector","type":"module","doc":"User agent parser library Preparation Verify your supervision setup according to UAInspector.Supervisor Revise the default configuration values of UAInspector.Config and adjust to your project/environment where necessary Download a copy of the database files as outlined in UAInspector.Downloader Usage iex(1)&gt; UAInspector.parse(&quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot;) %UAInspector.Result{ client: %UAInspector.Result.Client{ engine: &quot;WebKit&quot;, engine_version: &quot;537.51.11&quot;, name: &quot;Mobile Safari&quot;, type: &quot;browser&quot;, version: &quot;7.0&quot; }, device: %UAInspector.Result.Device{ brand: &quot;Apple&quot;, model: &quot;iPad&quot;, type: &quot;tablet&quot; }, os: %UAInspector.Result.OS{ name: &quot;iOS&quot;, platform: :unknown, version: &quot;7.0.4&quot; }, user_agent: &quot;Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53&quot; } iex(2)&gt; UAInspector.parse(&quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot;) %UAInspector.Result.Bot{ category: &quot;Search bot&quot;, name: &quot;Googlebot&quot;, producer: %UAInspector.Result.BotProducer{ name: &quot;Google Inc.&quot;, url: &quot;http://www.google.com&quot; }, url: &quot;http://www.google.com/bot.html&quot;, user_agent: &quot;Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36&quot; } iex(3)&gt; UAInspector.parse(&quot;generic crawler agent&quot;) %UAInspector.Result.Bot{ category: :unknown, name: &quot;Generic Bot&quot;, producer: %UAInspector.Result.BotProducer{ name: :unknown, url: :unknown }, url: :unknown, user_agent: &quot;generic crawler agent&quot; } iex(4)&gt; UAInspector.parse(&quot;--- undetectable ---&quot;) %UAInspector.Result{ client: :unknown, device: :unknown, os: :unknown, user_agent: &quot;--- undetectable ---&quot; } The map key :user_agent will hold the unmodified passed user agent. If the device type cannot be determined a &quot;desktop&quot; device type will be assumed (and returned). Both :brand and :model are set to :unknown. When a bot agent is detected the result with be a UAInspector.Result.Bot struct instead of UAInspector.Result."},{"ref":"UAInspector.html#bot?/1","title":"UAInspector.bot?/1","type":"function","doc":"Checks if a user agent is a known bot."},{"ref":"UAInspector.html#hbbtv?/1","title":"UAInspector.hbbtv?/1","type":"function","doc":"Checks if a user agent is a HbbTV and returns its version if so."},{"ref":"UAInspector.html#parse/1","title":"UAInspector.parse/1","type":"function","doc":"Parses a user agent."},{"ref":"UAInspector.html#parse_client/1","title":"UAInspector.parse_client/1","type":"function","doc":"Parses a user agent without checking for bots."},{"ref":"UAInspector.html#ready?/0","title":"UAInspector.ready?/0","type":"function","doc":"Checks if UAInspector is ready to perform lookups. The true == ready? definition is made on the assumption that if there is at least one entry in all databases then lookups can be performed. Checking the state is done using the currently active databases. Any potentially concurrent reload requests are not considered."},{"ref":"UAInspector.html#reload/1","title":"UAInspector.reload/1","type":"function","doc":"Reloads all databases. You can pass [async: true|false] to define if the reload should happen in the background or block your calling process until completed."},{"ref":"UAInspector.Config.html","title":"UAInspector.Config","type":"module","doc":"Module to simplify access to configuration values with default values. There should be no configuration required to start using :ua_inspector if you rely on the default values: remote_database = &quot;https://raw.githubusercontent.com/matomo-org/device-detector/master/regexes&quot; remote_shortcode = &quot;https://raw.githubusercontent.com/matomo-org/device-detector/master&quot; config :ua_inspector, database_path: Application.app_dir(:ua_inspector, &quot;priv&quot;), http_opts: [], remote_path: [ bot: remote_database, browser_engine: remote_database &lt;&gt; &quot;/client&quot;, client: remote_database &lt;&gt; &quot;/client&quot;, device: remote_database &lt;&gt; &quot;/device&quot;, os: remote_database, short_code_map: remote_shortcode, vendor_fragment: remote_database ], remote_release: &quot;master&quot;, startup_sync: false yaml_file_reader: {:yamerl_constr, :file, [[:str_node_as_binary]]} The default :database_path is evaluated at runtime and not compiled into a release! How to Configure There are two ways to change the configuration values with the preferred way depending on your environment and personal taste. Static Configuration If you can ensure the configuration are static and not dependent on i.e. the server your application is running on, you can use a static approach by modifying your config.exs file: config :ua_inspector, database_path: &quot;/path/to/ua_inspector/databases&quot; Dynamic Configuration If a compile time configuration is not possible or does not match the usual approach taken in your application you can use a runtime approach. This is done by defining an initializer module that will automatically be called by UAInspector.Supervisor upon startup/restart. The configuration is expected to consist of a {mod, fun} or {mod, fun, args} tuple: # {mod, fun} config :ua_inspector, init: {MyInitModule, :my_init_mf} # {mod, fun, args} config :ua_inspector, init: {MyInitModule, :my_init_mfa, [:foo, :bar]} defmodule MyInitModule do @spec my_init_mf() :: :ok def my_init_mf(), do: my_init_mfa(:foo, :bar) @spec my_init_mfa(atom, atom) :: :ok def my_init_mfa(:foo, :bar) do priv_dir = Application.app_dir(:my_app, &quot;priv&quot;) Application.put_env(:ua_inspector, :database_path, priv_dir) end end The function is required to always return :ok. Startup Behaviour Databases are loaded asynchronously when starting the application using a :reload cast. This default behaviour can lead to the first parsing calls to work with an empty database and therefore not return the results you expect. You can change this behaviour to have the application force a synchronous database loading during the initial startup: config :ua_inspector, startup_sync: true Database Configuration Configuring the database to use can be done using two related values: :database_path :remote_path The :database_path is the directory to look for when loading the databases. It is also the place where UAInspector.Downloader stores a downloaded copy. For the time being the detailed list of database files is not configurable. This is a major caveat for personal database copies and short code mappings (they have additional path information appended to the base). This behaviour is subject to change. The full configuration for remote paths contains the following values: config :ua_inspector remote_path: [ bot: &quot;http://example.com&quot;, browser_engine: &quot;http://example.com&quot;, client: &quot;http://example.com&quot;, device: &quot;http://example.com&quot;, os: &quot;http://example.com&quot;, short_code_map: &quot;http://example.com&quot;, vendor_fragment: &quot;http://example.com&quot; ] Default Database Release Version If you are using the default database the newest version from the &quot;master&quot; branch will be used. You can also configure a different release to be used: config :ua_inspector, remote_release: &quot;v1.0.0&quot; Download Configuration Using the default configuration all download requests for your database files are done using :hackney. To pass custom configuration values to hackney you can use the key :http_opts: config :ua_inspector, http_opts: [proxy: &quot;http://mycompanyproxy.com&quot;] Please see :hackney.request/5 for a complete list of available options. If you want to change the library used to download the databases you can configure a module implementing the UAInspector.Downloader.Adapter behaviour: config :ua_inspector, downloader_adapter: MyDownloaderAdapter YAML File Reader Configuration By default the library :yamerl will be used to read and decode the yaml database files. You can configure this reader to be a custom module: config :ua_inspector, yaml_file_reader: {module, function} config :ua_inspector, yaml_file_reader: {module, function, extra_args} The configured module will receive the file to read as the first argument with any optionally configured extra arguments after that."},{"ref":"UAInspector.Config.html#database_path/0","title":"UAInspector.Config.database_path/0","type":"function","doc":"Returns the configured database path. If the path is not defined the priv dir of :ua_inspector as returned by Application.app_dir(:ua_inspector, &quot;priv&quot;) will be used."},{"ref":"UAInspector.Config.html#database_url/2","title":"UAInspector.Config.database_url/2","type":"function","doc":"Returns the remote url of a database file."},{"ref":"UAInspector.Config.html#default_remote_database?/0","title":"UAInspector.Config.default_remote_database?/0","type":"function","doc":"Returns whether the remote database (at least one type) matches the default."},{"ref":"UAInspector.Config.html#downloader_adapter/0","title":"UAInspector.Config.downloader_adapter/0","type":"function","doc":"Returns the configured downloader adapter module. The modules is expected to adhere to the behaviour defined in UAInspector.Downloader.Adapter."},{"ref":"UAInspector.Config.html#get/2","title":"UAInspector.Config.get/2","type":"function","doc":"Provides access to configuration values with optional environment lookup."},{"ref":"UAInspector.Config.html#init_env/0","title":"UAInspector.Config.init_env/0","type":"function","doc":"Calls the optionally configured init method."},{"ref":"UAInspector.Config.html#yaml_file_reader/0","title":"UAInspector.Config.yaml_file_reader/0","type":"function","doc":"Returns the {mod, fun, extra_args} to be used when reading a yaml file."},{"ref":"UAInspector.Downloader.html","title":"UAInspector.Downloader","type":"module","doc":"Fetches copies of the configured database files. All files will be stored in the configured database path with the default setting being the result of Application.app_dir(:ua_inspector, &quot;priv&quot;). Please consult UAInspector.Config for details on database configuration. Mix Task Please see Mix Tasks.UaInspector.Download if you are interested in using a mix task to obtain your database files."},{"ref":"UAInspector.Downloader.html#download/0","title":"UAInspector.Downloader.download/0","type":"function","doc":"Performs download of all files."},{"ref":"UAInspector.Downloader.html#download/1","title":"UAInspector.Downloader.download/1","type":"function","doc":"Performs download of configured database files and short code maps."},{"ref":"UAInspector.Downloader.Adapter.html","title":"UAInspector.Downloader.Adapter","type":"behaviour","doc":"Behaviour for modules used by the downloader."},{"ref":"UAInspector.Downloader.Adapter.html#c:read_remote/1","title":"UAInspector.Downloader.Adapter.read_remote/1","type":"callback","doc":"Reads a database file from a remote location and returns it&#39;s contents."},{"ref":"UAInspector.Result.html","title":"UAInspector.Result","type":"module","doc":"Result struct."},{"ref":"UAInspector.Result.html#t:t/0","title":"UAInspector.Result.t/0","type":"type","doc":""},{"ref":"UAInspector.Result.Bot.html","title":"UAInspector.Result.Bot","type":"module","doc":"Bot result struct."},{"ref":"UAInspector.Result.Bot.html#t:t/0","title":"UAInspector.Result.Bot.t/0","type":"type","doc":""},{"ref":"UAInspector.Result.BotProducer.html","title":"UAInspector.Result.BotProducer","type":"module","doc":"Bot producer result struct."},{"ref":"UAInspector.Result.BotProducer.html#t:t/0","title":"UAInspector.Result.BotProducer.t/0","type":"type","doc":""},{"ref":"UAInspector.Result.Client.html","title":"UAInspector.Result.Client","type":"module","doc":"Client result struct."},{"ref":"UAInspector.Result.Client.html#t:t/0","title":"UAInspector.Result.Client.t/0","type":"type","doc":""},{"ref":"UAInspector.Result.Device.html","title":"UAInspector.Result.Device","type":"module","doc":"Device result struct."},{"ref":"UAInspector.Result.Device.html#t:t/0","title":"UAInspector.Result.Device.t/0","type":"type","doc":""},{"ref":"UAInspector.Result.OS.html","title":"UAInspector.Result.OS","type":"module","doc":"Operating system result struct."},{"ref":"UAInspector.Result.OS.html#t:t/0","title":"UAInspector.Result.OS.t/0","type":"type","doc":""},{"ref":"UAInspector.Supervisor.html","title":"UAInspector.Supervisor","type":"module","doc":"This supervisor module takes care of starting the required database storage processes. It is automatically started with the :ua_inspector application. If you do not want to automatically start the application itself you can adapt your configuration for a more manual supervision approach. Instead of adding :ua_inspector to your :applications list or using the automatic discovery you need to add it to your :included_applications: def application do [ included_applications: [ # ... :ua_inspector, # ... ] ] end That done you can add UAInspector.Supervisor to your hierarchy: children = [ # ... UAInspector.Supervisor, # .. ]"},{"ref":"UAInspector.Supervisor.html#child_spec/1","title":"UAInspector.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."}]